#include <iostream>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <ctime>
#include <cstdlib>

using namespace std;

int N,C,C1[501],B,b,B1[501][2],A[351][351],A1[351][351],A2[351][351],A3[351][351],F,K,k,S[150000][3],T,Y2,X2,Z1[100000],Z2[100000];

//void print() { cout<<endl; for (int y=0; y<N; ++y) { for (int x=0; x<N; ++x) cout<<setw(3)<<A1[y][x]; cout<<" |";
//for (int x=0; x<N; ++x) cout<<setw(3)<<A2[y][x]; cout<<" |"; for (int x=0; x<N; ++x) cout<<setw(3)<<A3[y][x]; cout<<endl;} }

void colorize(int c) { for (int y=0; y<N; ++y) for (int x=0; x<N; ++x) if (A2[y][x]==2) A1[y][x]=c; }

void qsS(int L,int H) { int i=L,j=H,x=S[(L+H)/2][2],t; do { while (S[i][2]>x) ++i; while (S[j][2]<x) --j;
if (i<=j){ t=S[i][0]; S[i][0]=S[j][0]; S[j][0]=t; t=S[i][1]; S[i][1]=S[j][1]; S[j][1]=t; t=S[i][2]; S[i][2]=S[j][2]; S[j][2]=t; i++; j--;} }
while (i<=j); if (L<j) qsS(L,j); if (H>i) qsS(i,H); }

void qsB1(int L,int H) { int i=L,j=H,x=B1[(L+H)/2][1],t; do { while (B1[i][1]>x) ++i; while (B1[j][1]<x) --j;
if (i<=j){ t=B1[i][0]; B1[i][0]=B1[j][0]; B1[j][0]=t; t=B1[i][1]; B1[i][1]=B1[j][1]; B1[j][1]=t; i++; j--;} }
while (i<=j); if (L<j) qsB1(L,j); if (H>i) qsB1(i,H); }

void flood1(int y,int x,int c) {
	if ( A2[y][x]==-1 && A1[y][x]==c ) {
		A2[y][x]=T;
		++S[T][2];
		if(y>0)flood1(y-1,x,c);if(x>0)flood1(y,x-1,c);if(y<N-1)flood1(y+1,x,c);if(x<N-1)flood1(y,x+1,c);
	}
}

void flood2(int y,int x,int c) {
	if (A2[y][x]<2) {
		if (A1[y][x]==c) {
			A2[y][x]=2;
			--F;
			if(y>0)flood2(y-1,x,c); if(x>0)flood2(y,x-1,c); if(y<N-1)flood2(y+1,x,c); if(x<N-1)flood2(y,x+1,c);
		} else {
			A2[y][x]=1;
		}
	}
}

void flood3(int y,int x,int c) {
	if ( A2[y][x]<2 && A3[y][x]<1 && A1[y][x]==c ) {
		A3[y][x]=1;
		++C1[c];
		if (y>N/4 && y<3*N/4 && x>N/4 && x<3*N/4) ++C1[c];
		if(y>0)flood3(y-1,x,c);if(x>0)flood3(y,x-1,c);if(y<N-1)flood3(y+1,x,c);if(x<N-1)flood3(y,x+1,c);
	}
}

int main() {
	clock_t clck1=clock(),clck2=clck1,clck3=clck1,clckDiffMax=0;
	ifstream in("flood-it.in",iostream::in);
	in>>N>>C;
	for (int y=0; y<N; ++y) for (int x=0; x<N; ++x) in>>A[y][x];
	in.close();
	

	T=0;
	for (int y=0; y<N; ++y) for (int x=0; x<N; ++x) {A1[y][x]=A[y][x]; A2[y][x]=-1; A3[y][x]=0;}
    for (int y=0; y<N; ++y) for (int x=0; x<N; ++x) if ( A2[y][x]==-1 ) { S[T][0]=y; S[T][1]=x; S[T][2]=0; flood1(y,x,A1[y][x]); ++T; }
	for (int i=0; i<T; ++i) {
		if ( S[i][0]>N/4 && S[i][0]<3*N/4 && S[i][1]>N/4 && S[i][1]<3*N/4 ) S[i][2]+=2;
		if ( S[i][0]>3*N/8 && S[i][0]<5*N/8 && S[i][1]>3*N/8 && S[i][1]<5*N/8 ) S[i][2]+=2;
	}
	qsS(0,T-1);
	
	
	K=100000;
    clck3=clock();
	for (int i=0; i<T; ++i) {
        if ( 950-clck1-clck3<clckDiffMax && i>0 ) break;
		for (int y2=0; y2<N; ++y2) for (int x2=0; x2<N; ++x2) {A1[y2][x2]=A[y2][x2]; A2[y2][x2]=0;}
		int y1=S[i][0], x1=S[i][1];
		A2[y1][x1]=1; b=0; B=1; F=N*N; k=0;

		while (F>0) {
			for (int y2=0; y2<N; ++y2) for (int x2=0; x2<N; ++x2) if (A2[y2][x2]==1) flood2(y2,x2,A1[y1][x1]);

			if ( B<10 || 2*b*b>B )
			{
				for (int c=1; c<=C; ++c) C1[c]=0;
                for (int y2=0; y2<N; ++y2) for (int x2=0; x2<N; ++x2) A3[y2][x2]=0;
                for (int y2=0; y2<N; ++y2) for (int x2=0; x2<N; ++x2) if (A2[y2][x2]==1) flood3(y2,x2,A1[y2][x2]);

				B=0; b=0;
				for (int c=1; c<=C; ++c) if (C1[c]>0) { B1[B][0]=c; B1[B][1]=C1[c]; ++B; }
				qsB1(0,B-1);
			}

			Z1[k++]=A1[y1][x1]=B1[b][0];
			colorize(B1[b++][0]);
		}
		--k;

		if (k<K) {
			K=k;
			for (int k=0; k<K; ++k) Z2[k]=Z1[k];
			Y2=y1;
			X2=x1;
		}

		clck2=clck3;
        clck3=clock();
        if (clck3-clck2>clckDiffMax) clckDiffMax=clck3-clck2;
	}
	
	
	
	ofstream out("flood-it.out",iostream::out);
	out<<K<<endl<<Y2<<" "<<X2<<endl;
	for (int k=0; k<K; ++k) out<<Z2[k]<<endl;
	out.close();
//system("pause");
	return 0;
}
